package io.tswf.transmutations.view.exception

import groovy.transform.CompileStatic
import org.objectweb.asm.commons.Method
import org.objectweb.asm.tree.ClassNode

@CompileStatic
class CantReachMethodException extends RuntimeException {
    ClassNode targetClass
    Method targetMethod

    CantReachMethodException(ClassNode targetClass, Method targetMethod) {
        super("The method ${targetMethod.javaFullName} was not found in ${targetClass.javaName}!")
        this.targetClass = targetClass
        this.targetMethod = targetMethod
    }
}
