package io.tswf.transmutations.view.exception

import groovy.transform.CompileStatic
import org.objectweb.asm.tree.ClassNode
import org.objectweb.asm.tree.MethodNode

@CompileStatic
class ConflictingMethodFoundException extends RuntimeException implements IConflictResolveExceptionBypassMarker {

    ClassNode targetClass
    MethodNode alreadyExisting
    MethodNode newMethod
    ClassNode newMethodOwner

    ConflictingMethodFoundException(
            ClassNode targetClass,
            MethodNode alreadyExisting,
            ClassNode newMethodOwner,
            MethodNode newMethod
    ) {
        super("Conflicting method ${alreadyExisting.javaFullName} found in ${targetClass.javaName} while trying to inject ${newMethod.javaFullName} from ${newMethodOwner.javaName}!")
        this.targetClass = targetClass
        this.alreadyExisting = alreadyExisting
        this.newMethod = newMethod
        this.newMethodOwner = newMethodOwner
    }
}
