package io.tswf.transmutations.view.exception

import groovy.transform.CompileStatic
import io.tswf.transmutations.view.meta.ViewMethodMetadata

@CompileStatic
class InvalidViewMethodException extends RuntimeException {
    ViewMethodMetadata viewMethodMeta

    InvalidViewMethodException(String message, ViewMethodMetadata viewMethodMeta) {
        super("The method ${viewMethodMeta.viewMethod.javaFullName} in ${viewMethodMeta.view.viewClass.javaName} is invalid because ${message}")
        this.viewMethodMeta = viewMethodMeta
    }
}
