package io.tswf.transmutations.view.reading.mappers

import com.google.auto.service.AutoService
import groovy.transform.CompileStatic
import io.tswf.transmutations.view.annotation.MethodInvoke
import io.tswf.transmutations.view.generation.mapper.MethodInvokeMapper
import io.tswf.transmutations.view.reading.IViewMethodMapperReader
import io.tswf.transmutations.view.reading.ViewMethodMapperReadingContext
import org.objectweb.asm.commons.Method

@AutoService(IViewMethodMapperReader)
@CompileStatic
class MethodInvokeMapperReader extends AbstractMethodInvokeMapperReader {

    public static final Set<String> PREFIXES = [ "invoke", "call" ] as Set

    MethodInvokeMapperReader() {
        super(MethodInvoke, PREFIXES)
    }

    @Override
    void onMethodReaded(ViewMethodMapperReadingContext readingContext, Method methodDescription) {
        readingContext.result << new MethodInvokeMapper(methodDescription)
    }
}
